#ifndef CONTENEUR_H
#define CONTENEUR_H

using namespace std ;

#include <iostream>
#include <cmath>

#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <qmessagebox.h>


#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
//#include <qslider.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qscrollview.h>


class planche ;

class conteneur : public QWidget
{
    Q_OBJECT

public :
    conteneur( );
    ~conteneur();

signals :
    void signalSaveImage() ;
    void signalCalculate() ;
    void signalRestart( int pourcent, bool withoutBug ) ;
    void signalRandom(  int nbVoisins, bool sym ) ;
    void signalBugChanged(bool) ;
    void signalSizeChanged(int) ;
    void signalLoadAppli( int*,int,int ) ;

private slots :
    void slotSaveImage() ;
    void slotCalculate() ;
    void slotRestart( int pourcent, bool withoutBug ) ;
    void slotRandom( int nbVoisins, bool sym ) ;
    void slotBugChanged(bool) ;
    void slotSizeChanged(int) ;
    void slotLoadAppli( int*,int,int  ) ;

protected :
    virtual void keyPressEvent( QKeyEvent*  ) ;
    virtual void resizeEvent(QResizeEvent* ) ;

private :

    QScrollView* _scrollview ;
    planche* _planche ;
};

#endif

