#include <qfiledialog.h>
#include <qmessagebox.h>

#include "planche.h"

void planche :: slotBugChanged( bool b )
{
 withoutBug = b ;
}

void planche :: slotRandom( int nbVoisinsNew , bool symm)
{
 int i ;
 int HalfNbConfigurations, NbConfigurations ;
 time_t rand_germe ;

 HalfNbConfigurations = 1 << (nbVoisinsNew) ;
 NbConfigurations = 1 << (nbVoisinsNew+1) ;
 rand_germe = time(NULL) ;
 //rand_germe = 7 ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;

 if (nbVoisinsNew != nbVoisins)
	{
	 delete appli ;
	 appli = new int [NbConfigurations] ;
	 //cout << " CHANGEMENT DE TALLLE !!! = " << NbConfigurations << endl ;
	 nbVoisins = nbVoisinsNew ;
	}

 for(i=0;i < HalfNbConfigurations;i++) appli[i] = rand() & 1 ;

 if (symm) for(i=HalfNbConfigurations;i<NbConfigurations;i++) appli[i] = appli[NbConfigurations-i-1] ;
	else for(i=HalfNbConfigurations;i<NbConfigurations;i++) appli[i] = rand() & 1 ;
}





void planche :: initialisePlancheProgress(int pourcent, bool withoutBug )
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int i,j,k,l,ll,indice, halfNBvoisins, size_lim ;
 int* t ;
 time_t rand_germe ;


 rand_germe = time(NULL) ;
 //rand_germe = 7 ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;
 switch (pourcent)
	{
	 case 0   : for(i=0;i<sizeX;i++) old[i] = 1 ; break ;
	 case 100 : for(i=0;i<sizeX;i++) old[i] = 0 ; break ;
	 default  : pourcent++ ;
	 	    for(i=0;i<sizeX;i++) if ((rand() % pourcent)==0) old[i] = 1 ; else old[i] = 0 ;
	}

 halfNBvoisins = nbVoisins >> 1 ;
 size_lim = sizeX - halfNBvoisins ;

 windowpainter.begin( this ) ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.setPen( QColor(0,0,0) ) ;
 bufferpainter.setPen( QColor(0,0,0) ) ;
 for(i=0;i<sizeX;i++)
	{
	 //cout << " " << old[i] ;
	 if (old[i]==0) continue ;
	 windowpainter.drawPoint(i,0) ;
	 bufferpainter.drawPoint(i,0) ;
	}

 _progressD->setTotalSteps( sizeY-1 ) ;

 if (withoutBug)
 {
  //cout << " ok !!! boss " << endl ;
  for(j=1;j<sizeY;j++)
	{
	 for(k=0;k<halfNBvoisins;k++)
		{
		 indice = 0 ;
		 ll= 1 << nbVoisins ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[k] = appli[indice] ;
		}

	 for(i=halfNBvoisins;i<size_lim;i++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins;l<=halfNBvoisins;l++,ll >>= 1 ) indice += ll*old[i+l] ;
	 	 current[i] = appli[indice] ;
		}

	 for(k=-halfNBvoisins;k<0;k++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[sizeX+k] = appli[indice] ;
		}

	 t = old ;
	 old = current ;
	 current = t ;
	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) continue ;
		 windowpainter.drawPoint(i,j) ;
		 bufferpainter.drawPoint(i,j) ;
		}
	 _progressD->setProgress(j) ;
	}
 }
 else
 {
  // --------------         PAS FAITE         ---------------------
 }
 windowpainter.end() ;
 bufferpainter.end() ;
}


void planche :: initialisePlanche(int pourcent, bool withoutBug )
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int i,j,k,l,ll,indice, halfNBvoisins, size_lim ;
 int* t ;
 time_t rand_germe ;


 rand_germe = time(NULL) ;
 //rand_germe = 7 ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;
 switch (pourcent)
	{
	 case 0   : for(i=0;i<sizeX;i++) old[i] = 1 ; break ;
	 case 100 : for(i=0;i<sizeX;i++) old[i] = 0 ; break ;
	 default  : pourcent++ ;
	 	    for(i=0;i<sizeX;i++) if ((rand() % pourcent)==0) old[i] = 1 ; else old[i] = 0 ;
	}

 halfNBvoisins = nbVoisins >> 1 ;
 size_lim = sizeX - halfNBvoisins ;

 windowpainter.begin( this ) ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.setPen( QColor(0,0,0) ) ;
 bufferpainter.setPen( QColor(0,0,0) ) ;
 for(i=0;i<sizeX;i++)
	{
	 //cout << " " << old[i] ;
	 if (old[i]==0) continue ;
	 windowpainter.drawPoint(i,0) ;
	 bufferpainter.drawPoint(i,0) ;
	}

 if (withoutBug)
 {
  //cout << " ok !!! boss " << endl ;
  for(j=1;j<sizeY;j++)
	{
	 for(k=0;k<halfNBvoisins;k++)
		{
		 indice = 0 ;
		 ll= 1 << nbVoisins ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[k] = appli[indice] ;
		}

	 for(i=halfNBvoisins;i<size_lim;i++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins;l<=halfNBvoisins;l++,ll >>= 1 ) indice += ll*old[i+l] ;
	 	 current[i] = appli[indice] ;
		}

	 for(k=-halfNBvoisins;k<0;k++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[sizeX+k] = appli[indice] ;
		}

	 t = old ;
	 old = current ;
	 current = t ;
	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) continue ;
		 windowpainter.drawPoint(i,j) ;
		 bufferpainter.drawPoint(i,j) ;
		}
	}
 }
 else
 {
  // --------------         PAS FAITE         ---------------------
 }
 windowpainter.end() ;
 bufferpainter.end() ;
}


planche :: planche()
{
 int nbConfigurations ;

 setBackgroundMode( NoBackground ) ;
 _progressD = new QProgressDialog( this,"_progessD") ;
 sizeX = SIZE_X ;
 sizeY = SIZE_Y ;

 old     = new int[SIZE_X] ;
 current = new int[SIZE_X] ;

 // initialisation !
 //_parametre = new Parametres() ;
 //_parametre->show() ;

 nbVoisins = 4 ;
 nbConfigurations = 1 << (nbVoisins+1) ;

 appli = new int[nbConfigurations] ;

 slotRandom( nbVoisins, false ) ;

 _buffer.resize( SIZE_X ,SIZE_Y ) ;
 _buffer.fill() ;

 bitBlt( this , 0 , 0 , &_buffer ) ;

 withoutBug = true ;
 initialisePlancheProgress( 1,true ) ;

 resize( QSize(SIZE_X, SIZE_Y) );
}

planche :: ~planche()
{
 delete old ;
 delete current ;
 delete appli ;
}

void planche :: slotRestart(int pour, bool withoutBug )
{
 _buffer.fill() ;
 bitBlt( this , 0 , 0 , &_buffer ) ;

 initialisePlanche( pour,withoutBug ) ;
}

void planche :: slotSizeChanged(int r)
{
 switch(r)
	{
	 case 0 : sizeX = 511 ; sizeY = 128 ; break ;
	 case 1 : sizeX = 1031 ; sizeY = 256 ; break ;
	 case 2 : sizeX = 2053 ; sizeY = 512 ; break ;
	 case 3 : sizeX = 3989 ; sizeY = 1024 ; break ;
	 case 4 : sizeX = 8209 ; sizeY = 2048 ; break ;
	 case 5 : sizeX = 16411 ; sizeY = 4096 ; break ;
	 default : sizeX = 1031 ; sizeY = 256 ;
	}

 //cout << " sizeX = " << sizeX << " sizeY = "  << sizeY << endl ;
 resize( sizeX, sizeY );
 _buffer.resize(sizeX, sizeY) ;
 delete old ;
 delete current ;
 old = new int[sizeX] ;
 current = new int[sizeX] ;

}

void planche :: slotCalculate()
{
 QPainter bufferpainter ;
 int i,j,k,l,ll,halfNBvoisins,indice,size_lim ;
 int* t ;
 //bool withoutBug ;

 //_parametre->getParam( &withoutBug ) ;
 halfNBvoisins = nbVoisins >> 1 ;
 size_lim = sizeX - halfNBvoisins ;

 bufferpainter.begin( &_buffer ) ;

 if (withoutBug)
 {
 for(j=0;j < SPEED;j++)
	{
	 bitBlt( this , 0 , 0 , &_buffer , 0 , 1 , sizeX , sizeY-1 ) ;
	 bitBlt( &_buffer , 0 , 0 , &_buffer , 0 , 1 , sizeX , sizeY-1 ) ;


	 for(k=0;k<halfNBvoisins;k++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[k] = appli[indice] ;
		}

	 for(i=halfNBvoisins;i<size_lim;i++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins;l<=halfNBvoisins;l++,ll >>= 1 ) indice += ll*old[i+l] ;
	 	 current[i] = appli[indice] ;
		}

	 for(k=-halfNBvoisins;k<0;k++)
		{
		 indice = 0 ;
		 ll=(1 << nbVoisins) ;
		 for(l=-halfNBvoisins+k;l<0;l++,ll >>= 1) indice += ll*old[sizeX+l] ;
		 for(l=0;l<=halfNBvoisins+k;l++,ll >>= 1 ) indice += ll*old[l] ;
		 current[sizeX+k] = appli[indice] ;
		}

	 t = old ;
	 old = current ;
	 current = t ;

	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) bufferpainter.setPen( QColor(255,255,255) ) ;
			else bufferpainter.setPen( QColor(0,0,0) ) ;

		 bufferpainter.drawPoint(i,sizeY-1) ;
		}
	}
 }
 else
 {
   //  refaire
 }

 bufferpainter.end() ;
}

void planche :: slotSaveImage()
{
 int temp,i ;
 QString filename = QFileDialog::getSaveFileName(".",".bmp", this ) ;
 if (!filename.isEmpty())
	{
	 if ( !_buffer.save( filename+".bmp", "BMP") )
 		QMessageBox::warning(0,"Erreur d'enregistrement" ,
					"impossible d'enregistrer le fichier") ;
	 QFile file( filename+".txt" ) ;
	 if (file.open( IO_WriteOnly ))
		{
		 QTextStream stream( &file ) ;
		 temp = 1 << (nbVoisins+1) ;
		 stream << "Number of configurations = " << temp << endl ;
		 for(i=0;i<temp;i++)
			stream << " appli[" << i << "] = " << appli[i] << endl ;
		 file.close() ;
		}
	}
}



void planche :: keyPressEvent( QKeyEvent* event )
{
 int rep ;
 //cout << event->text() << " touche !!! \n" ;
 rep = event->key() ;

 if (rep == Qt::Key_Space )
	{
	 slotCalculate() ;
	}
 if (rep == Qt::Key_S )
	{
	 slotSaveImage() ;
	}

}

void planche :: paintEvent( QPaintEvent* event )
{
 //cout << "\n paintEvent" ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
}


void planche :: slotLoadAppli(int* a,int nbConfig,int nbV )
{
 int i ;

 if (nbV != nbVoisins)
	{
	 delete appli ;
	 appli = new int[nbConfig] ;
	 nbVoisins = nbV ;
	}
 for(i=0;i<nbConfig;i++) appli[i] = a[i] ;
}

void planche :: closeEvent( QCloseEvent* e )
{
 e->ignore() ;
}

/*
void planche :: resizeEvent( QResizeEvent* event)
{
 //cout << "\n resizeEvent" << endl ;

 //QPixmap save( _buffer) ;
 //_buffer.resize( event->size() ) ;
 //_buffer.fill( white) ;
 //bitBlt( &_buffer , 0 , 0 , &save ) ;
}
*/

