
#ifndef PARAMETRES_H
#define PARAMETRES_H

using namespace std ;

#include <iostream>
#include <cmath>

#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <qmessagebox.h>


#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
//#include <qslider.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qstring.h>

class conteneur ;


class parametres : public QWidget
{
    Q_OBJECT

public :
    parametres( );
    ~parametres();
    //void getParam( bool* bug ) ;
    //void setParamAppli(int* appl ) ;

signals :
    void signalSaveImage() ;
    void signalCalculate() ;
    void signalRestart( int pourcent, bool withoutBug ) ;
    void signalRandom(  int nbVoisins, bool sym ) ;
    void signalLoadAppli( int*,int,int ) ;

private slots :
    void slotRestart() ;
    void slotRandom() ;
    void slotLoadAppli() ;

protected :
    virtual void keyPressEvent( QKeyEvent*  ) ;
    virtual void resizeEvent(QResizeEvent* ) ;

private :

    QLabel* textLabel1;
    QLabel* textLabel2;
    QLabel* textLabel3;
    QGroupBox* groupBox2;
    QPushButton* pushButton2;
    QLabel* textLabel5;
    QLabel* textLabel6;
    QComboBox* comboBox2;
    QGroupBox* groupBox1;
    QPushButton* pushButton1;
    QPushButton* pushButtonL;
    QCheckBox* checkBox1;
    QLabel* textLabel4;
    QComboBox* comboBox1;
    QGroupBox* groupBox3;
    QCheckBox* checkBox2;
    QLabel* textLabel1_2;
    QComboBox* comboBox3;


    conteneur* _conteneur ;
};

#endif

